//
//
//
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
//#include <g++/Integer.h>
#include <signal.h>
#include <ncurses/curses.h>

#include "lib/xvmsupport.h"

extern char *ItoA(int);

#define XVM_VER_CONSOLE "0.1.5"

#define MAX_HIST 20
#define NEXT 1
#define PREV 2

xvmqueue mbuf;
int conflag=0;
WINDOW *fdsin;
int tempint;
int ecompl;
int busyflag=0;
char* hist[MAX_HIST];
int curhist=0;
//int prevhist=MAX_HIST-1;

int main();
int InitServer();
int MainLoop();
int PrintRegs();
int PrintComms();
char* GetAbout();
char* GetVersion();
int ProsessInput();
int ProsessMessage();
int ReadInput(char *temps);
char* History(int v,char* line);

void ServerDead(int sig){
	endwin();
	sig=0;
	perror("Vive la Mort!! Server is CRASHED ");
	exit(1);
};	

int 
main(){
	signal(SIGCHLD,ServerDead);
	if((int)(fdsin=initscr())==ERR){
		perror("Can`t run ncurses ");
		exit(1);
	};
	idlok(fdsin,TRUE);
	scrollok(fdsin,TRUE);
	clearok(fdsin,TRUE);
	//traceon();
	for(tempint=0;tempint<MAX_HIST;tempint++){
		hist[tempint]=new char[MAX_XQ_MTEXT_LEN];
		strcpy(hist[tempint],"\0\0\0\0\0\0\0\0\0\0\0\0");
	};
	printw(GetAbout());
	refresh();
	InitServer();
	MainLoop();
	for(tempint=0;tempint<MAX_HIST;tempint++){
		delete hist[tempint];
	};
	endwin();
};

int 
InitServer(){
	pid_t tryf;
	int trye;
	if((tryf=fork())==0){
		if((trye=execlp("xvmserver","xvmserver",NULL))==-1){
			endwin();
			perror("problem with starting server");
			exit(1);
		};
	};
	sleep(2);
	if(ConnectQueue()==-1){
		endwin();
		perror("Can`t connect queque ");
		exit(1);
	};
	return 1;
};

int 
MainLoop(){
	int CStatus=0;
	while(CStatus==0){
		ProsessMessage();
		CStatus=ProsessInput();		
	};
	sleep(1);
	ProsessMessage();
	printw("\n\t=== EXIT ===\n\n");
	refresh();
	return 1;
};

int 
ProsessInput(){
	//char temp;
	char sbuf[MAX_XQ_MTEXT_LEN];
	char* stext=sbuf;
	char* stok[4]={NULL,NULL,NULL,NULL};
	if(conflag==0){
		clrtobot();
		clrtoeol();
		refresh();
  		printw("CONSOLE = ");
		conflag=1;
		refresh();
	};
	if(ReadInput(stext)==1){
		int compl=0;
		conflag=0;
		printw("\n");
		stok[0]=strtok(stext," ");
		stok[1]=strtok(NULL," ");
		stok[2]=strtok(NULL," ");
		if(stok[0]==NULL){
			stok[0]="\0";
		};
		if(stok[1]==NULL){
			stok[1]="\0";
		};
		if(stok[2]==NULL){
			stok[2]="\0";
		};
		if(stok[3]==NULL){
			stok[3]="\0";
		};
		if(strcmp(stok[0],"save")==0 && compl==0){
			compl=1;
			if(*stok[1]=='\0'){
				printw("Must be : save FILE\n");
				refresh();
			}
			else{
				SendMessage(XQ_ST_SAVE,stok[1]);
			};
		};
		if(strcmp(stok[0],"load")==0 && compl==0){
			compl=1;
			if(*stok[1]=='\0'){
				printw("Must be : load FILE\n");
				refresh();
			}
			else{
				SendMessage(XQ_ST_LOAD,stok[1]);
			};
		};
		if(strcmp(stok[0],"get")==0 && compl==0){
			compl=1;
			if(*stok[1]=='\0'){
				printw("Must be : get error|cur|prev|status\n");
				refresh();
			}
			else{
				ecompl=0;
				if(strcmp(stok[1],"error")==0 && ecompl==0){
					ecompl=1;
					SendMessage(XQ_ST_GET_ERROR);
					while(!ReadMessage(&mbuf));
					if(mbuf.msubtype==XQ_ST_GET_ERROR){
						printw("Error = %s\n",mbuf.mtext);
					}
					else{
						printw("Queue ERROR : %s",mbuf.mtext);
					};
					refresh();
				};
				if(strcmp(stok[1],"cur")==0 && ecompl==0){
					ecompl=1;					
					SendMessage(XQ_ST_GET_CURCOMMNO);
					while(!ReadMessage(&mbuf));
					if(mbuf.msubtype==XQ_ST_GET_CURCOMMNO){
						printw("Current comm no = %d\n",mbuf.mno);
					}
					else{
						printw("Queue ERROR : %s",mbuf.mtext);
					};
					refresh();
				};
				if(strcmp(stok[1],"prev")==0 && ecompl==0){
					ecompl=1;
					SendMessage(XQ_ST_GET_PREVCOMMNO);
					while(!ReadMessage(&mbuf));
					if(mbuf.msubtype==XQ_ST_GET_PREVCOMMNO){
						printw("Prev comm no = %d\n",mbuf.mno);	
					}
					else{
						printw("Queue ERROR : %s",mbuf.mtext);
					};
					refresh();
				};
				if(strcmp(stok[1],"status")==0 && ecompl==0){
					ecompl=1;
					SendMessage(XQ_ST_GET_PROGSTATUS);
					while(!ReadMessage(&mbuf));
					if(mbuf.msubtype==XQ_ST_GET_PROGSTATUS){
						printw("XVM status = %d\n",mbuf.mno);
					}
					else{
						printw("Queue ERROR : %s",mbuf.mtext);
					};
					refresh();
				};
				if(ecompl==0){
					ecompl=1;
					printw("Must be : get error|cur|prev|status\n");
					refresh();
				};
			};
		};
		if(strcmp(stok[0],"about")==0 && compl==0){
			compl=1;
			if(*stok[1]=='\0'){
				printw("Must be : about xvm|server|console|supp\n");
				refresh();
			}
			else{
				ecompl=0;
				if(strcmp(stok[1],"xvm")==0 && ecompl==0){
					ecompl=1;
					SendMessage(XQ_ST_GET_XVMABOUT);
				};
				if(strcmp(stok[1],"server")==0 && ecompl==0){
					ecompl=1;
					SendMessage(XQ_ST_GET_SERVERABOUT);
				};
				if(strcmp(stok[1],"console")==0 && ecompl==0){
					ecompl=1;
					printw(GetAbout());
				};
				if(strcmp(stok[1],"supp")==0 && ecompl==0){
					ecompl=1;
					SendMessage(XQ_ST_GET_SUPPORTABOUT);
				};
				if(ecompl==0){
					ecompl=1;
					printw("Must be : about xvm|server|console|supp\n");
					refresh();
				};
			};
		};
		if((strcmp(stok[0],"init")==0 || (strlen(stok[0])==1 && 
				*stok[0]=='i')) && compl==0){
			mbuf.msubtype=XQ_ST_COM;
			mbuf.mtext[0]=XQ_TCOM_INIT;
			SendMessage(&mbuf);
			compl=1;
		};
		if((strcmp(stok[0],"step")==0 || (strlen(stok[0])==1 && 
				*stok[0]=='s')) && compl==0){
			mbuf.msubtype=XQ_ST_COM;
			mbuf.mtext[0]=XQ_TCOM_STEP;
			SendMessage(&mbuf);
			compl=1;
		};
		if((strcmp(stok[0],"exec")==0 || (strlen(stok[0])==1 && 
				*stok[0]=='e')) && compl==0){
			SendMessage(XQ_ST_COM,XQ_TCOM_INIT);
			mbuf.msubtype=XQ_ST_COM;
			mbuf.mtext[0]=XQ_TCOM_EXEC;
			SendMessage(&mbuf);
			compl=1;
			busyflag=1;
		};
		if((strcmp(stok[0],"break")==0 || (strlen(stok[0])==1 && 
				*stok[0]=='b')) && compl==0){
			mbuf.msubtype=XQ_ST_COM;
			mbuf.mtext[0]=XQ_TCOM_BREAK;
			SendMessage(&mbuf);
			compl=1;
		};
		if((strcmp(stok[0],"quit")==0 || (strlen(stok[0])==1 && 
				*stok[0]=='q')) && compl==0){
			signal(SIGCHLD,SIG_DFL);
			mbuf.msubtype=XQ_ST_COM;
			mbuf.mtext[0]=XQ_TCOM_QUIT;
			SendMessage(&mbuf);
			printw("Waiting for server going done...\n");
			refresh();
			compl=2;
			return 1;
		};
		if((strcmp(stok[0],"list")==0 || (strlen(stok[0])==1 && 
				*stok[0]=='l')) && compl==0){
			ecompl=0;
			compl=1;
			if(stok[1]=="\0" && ecompl==0){
				ecompl=1;
				printw("Must be : (l)ist (r)egs|(c)omms\n");
				refresh();
			};
			if((strcmp(stok[1],"regs")==0 || (strlen(stok[1])==1 &&
					*stok[1]=='r'))&& ecompl==0){
				ecompl=1;
				PrintRegs();
			};
			if((strcmp(stok[1],"comms")==0 || (strlen(stok[1])==1 &&
					*stok[1]=='c')) && ecompl==0){
				ecompl=1;
				PrintComms();
			};
			if(ecompl==0){
				ecompl=1;
				printw("Must be : (l)ist (r)egs|(c)omms\n");
				refresh();
			};
		};
		if((strcmp(stok[0],"reg")==0 || (strlen(stok[0])==1 && 
				*stok[0]=='r')) && compl==0){
			compl=1;
			if(*stok[1]=='\0'){
				printw("Must be : (r)eg REGNO [REGVAL]\n");
				refresh();
			}
			else{
				SendMessage(XQ_ST_SET_REG,ItoA(atoi(stok[2])),atoi(stok[1]));
			};
		};
		if((strcmp(stok[0],"comm")==0 || (strlen(stok[0])==1 && 
				*stok[0]=='c')) && compl==0){
			compl=1;
			if(*stok[1]=='\0'){
				printw("Must be : (c)omm COMMNO [COMMSTAT]\n");
				refresh();
			}
			else{
				SendMessage(XQ_ST_SET_COMM,stok[2],atoi(stok[1]));
			};
		};
		if((*stok[0]!='\0' && compl==0) || (strcmp(stok[0],"?")==0 && compl==0)){
			compl=1;
			printw("Command must be:\n");
			printw("\t(i)nit\n");
			printw("\t(s)tep\n");
			printw("\t(e)xec\n");
			printw("\t(b)reak\n");
			printw("\t(l)ist (r)egs|(c)omms\n");
			//printw("\t(l)ist (c)omms\n");
			printw("\t(r)eg REGNO REGVAL\n");
			printw("\t(c)omm COMMNO COMMSTAT\n");
			printw("\tsave FILE\n");
			printw("\tload FILE\n");
			printw("\tget error|cur|prev|status\n");
			printw("\tabout xvm|server|console|supp\n");
			printw("\t(q)uit\n");
			refresh();
		};
		if(compl==0 && *stok[0]!='\r'){
			compl=1;
			
		};
		if(compl!=2){
		        return 0;
		};
	}
	return 0;
};

int 
PrintRegs(){
	int temp;
	printw("Registers:\n--------------------------\n REG\tVAL\n--------------------------\n");
	refresh();
	SendMessage(XQ_ST_GET_REGLIST,"",1,10);
	for(temp=1;temp<11;temp++){
		printw(" %d\t",temp);
		strcpy(mbuf.mtext,"");
		WaitMessage(&mbuf);
		if(mbuf.msubtype!=XQ_ST_GET_REGLIST){
			printw("\nSome ERROR ocupt.\n");
			refresh();
			break;
		};
		printw(mbuf.mtext);
		printw("\n");
		refresh();
	};
	return 1;
};

int 
PrintComms(){
	int temp;
	printw("Commands:\n--------------------------\n COMM\tSTAT\n--------------------------\n");
	refresh();
	SendMessage(XQ_ST_GET_COMMLIST,"",1,20);
	for(temp=1;temp<21;temp++){
		printw(" %d\t",temp);
		strcpy(mbuf.mtext,"");
		WaitMessage(&mbuf);
		if(mbuf.msubtype!=XQ_ST_GET_COMMLIST){
			printw("\nSome ERROR ocupt.\n");
			refresh();
			break;
		};
		printw(mbuf.mtext);
		printw("\n");
		refresh();
	};
	return 1;
};

char* 
GetAbout(){
	static char ts[MAX_XQ_MTEXT_LEN];
	strcpy(ts,"XVM Console, ver: ");
	strcat(ts,GetVersion());
	strcat(ts," . Copyright(c) 1998, 1999 Dmitry Morozhnikov.\n");
	return ts;
};

char* 
GetVersion(){
	return XVM_VER_CONSOLE;
};

int 
ProsessMessage(){
	int mess=0;
	while((mess=ReadMessage(&mbuf))==1){
		switch(mbuf.msubtype){
			case XQ_ST_BUSY:
				busyflag=1;
			break;
			case XQ_ST_NOBUSY:
				busyflag=1;
			break;
			default:
				if(conflag!=0){
					nonl();
					printw("\r");
					clrtobot();
					clrtoeol();
					conflag=0;
					nl();
				};
				printw("SERVER = ");
				printw(mbuf.mtext);
				refresh();
			break;
		};
	};
	if(mess==-1){
		endwin();
		perror("Can`t read message ");
		exit(1);
	};
	return 1;
};

int
ReadInput(char *temps){
	char tempbuf[MAX_XQ_MTEXT_LEN];
	char *temps2=tempbuf;
	char tch;
	strcpy(temps2,"\0\0\0\0\0\0");
	//echo();
    	timeout(200);
	cbreak();
	noecho();
	//nonl();
	if((*temps2=getch())!=ERR){
		if(!busyflag){
		};
		timeout(-1);
		cbreak();
		ungetch(*temps2);
		refresh();
		tempint=0;
		while((tch=getch())!='\n'&& tempint<MAX_XQ_MTEXT_LEN){
			switch(tch){
				case '\177':
					if(tempint>0){
						addch('\010');
						addch(' ');
						addch('\010');
						tempint--;
						tempbuf[tempint+1]='\0';
						refresh();
						tch='\0';
					};
				break;
				case '\033':
					timeout(100);
					if((tch=getch())=='\133'){
						switch(tch=getch()){
							case '\101':
								if(tempint>0){
									tempint++;
								};
								tempbuf[tempint]='\0';
								if(tempint>0){
									tempint--;
								};
								while(tempint>0){
								    addch('\010');
								    delch();
								    tempint--;
								};
								strcpy(tempbuf,History(PREV,tempbuf));
								tempint=strlen(tempbuf);
								tempbuf[tempint+1]='\0';
								addstr(tempbuf);
								refresh();
								tch='\0';
							break;
							case '\102':
								if(tempint>0){
									tempint++;
								};
								tempbuf[tempint]='\0';
								if(tempint>0){
									tempint--;
								};
								while(tempint>0){
								    addch('\010');
								    delch();
								    tempint--;
								};
								if(tempbuf[0]!='\0'){
									strcpy(tempbuf,History(NEXT,tempbuf));
								}
								else{
									strcpy(tempbuf,"");
								};
								tempint=strlen(tempbuf);
								tempbuf[tempint+1]='\0';
								addstr(tempbuf);
								refresh();
								tch='\0';
							break;
						};
					};
					timeout(-1);
				break;
				default:
					tempbuf[tempint]=tch;
					tempint++;
					addch(tch);
					refresh();
					tch='\0';
					tempbuf[tempint]='\0';
				break;
			};
			//printw("\nHolded %o\n",tch);
			//refresh();
		};
		if(tempint>0){
			History(NEXT,tempbuf);
			strcpy(temps,temps2);
		}
		else{
			strcpy(temps,"");
		};
		nl();
		return 1;
	}
	else{
		return 0;
	};
};

char *
History(int v,char* line){
	switch(v){
		case PREV:
			if(curhist==0){
				strcpy(hist[curhist],line);
				curhist=MAX_HIST-1;
				if(hist[curhist][0]=='\0'){
					curhist=0;
					return hist[curhist];
				}
				else{
					return hist[curhist];
				};
			}
			else{
				strcpy(hist[curhist],line);
				curhist--;
				if(hist[curhist][0]=='\0'){
					curhist++;
					return hist[curhist];
				}
				else{
					return hist[curhist];
				};
			};
		break;
		case NEXT:
			if(curhist==(MAX_HIST-1)){
				strcpy(hist[curhist],line);
				curhist=0;
				return hist[curhist];
			}
			else{
				strcpy(hist[curhist],line);
				curhist++;
				return hist[curhist];
			};
		break;
	};
	return "";
};